Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Vertex.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Vertex.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Vertex.cs	(revision 10300)
@@ -55,4 +55,6 @@
     }
 
+    public object Content { get; set; }
+
     protected Vertex(Vertex original, Cloner cloner)
       : base(original, cloner) {
@@ -106,13 +108,7 @@
   [StorableClass]
   public class Vertex<T> : Vertex, IVertex<T> where T : class,IItem {
-    [Storable]
-    private T content;
-    public T Content {
-      get { return content; }
-      set {
-        if (value == null)
-          throw new ArgumentException("Node content cannot be null.");
-        content = value;
-      }
+    public new T Content {
+      get { return (T)base.Content; }
+      set { base.Content = value; }
     }
 
@@ -125,5 +121,4 @@
       : base(original, cloner) {
       Content = original.Content; // not sure if to Clone()
-
     }
 
@@ -131,12 +126,4 @@
       return new Vertex<T>(this, cloner);
     }
-
-    public Vertex(Vertex<T> node) {
-      Id = Guid.NewGuid().ToString();
-      Label = node.Label;
-      Content = node.Content;
-      InArcs = new List<IArc>(node.InArcs);
-      OutArcs = new List<IArc>(node.OutArcs);
-    }
   }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/FPGraph.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/FPGraph.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/FPGraph.cs	(revision 10300)
@@ -28,5 +28,5 @@
   [Item("Symbol graph", "A graph used to store the relationship between symbols in a population of individuals")]
   [StorableClass]
-  public class FPGraph : DirectedGraph<SymbolNode> {
+  public class FPGraph : DirectedGraph {
     [Storable]
     public Dictionary<int, List<SymbolNode>> Levels { get { return levels; } }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/GenealogyGraph.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/GenealogyGraph.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/GenealogyGraph.cs	(revision 10300)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -28,45 +29,37 @@
 namespace HeuristicLab.EvolutionTracking {
   [StorableClass]
-  [Item("GenealogyGraph", "A class representing a genealogy graph")]
-  public class GenealogyGraph : GenealogyGraph<IGenealogyGraphNode> {
-  }
-
-  [StorableClass]
-  [Item("GenealogyGraph", "A class representing a genealogy graph (of a population of individuals) without storing any content for vertices")]
-  public class GenealogyGraph<TVertex> : DirectedGraph<TVertex>, IGenealogyGraph<TVertex> where TVertex : class,IGenealogyGraphNode {
+  [Item("GenealogyGraph", "")]
+  public class GenealogyGraph : DirectedGraph, IGenealogyGraph {
     [Storable]
-    private Dictionary<double, LinkedList<TVertex>> ranks; // use a linked list for fast insertion/removal
-
-    public Dictionary<double, LinkedList<TVertex>> Ranks {
+    private Dictionary<double, LinkedList<IGenealogyGraphNode>> ranks; // use a linked list for fast insertion/removal
+    public Dictionary<double, LinkedList<IGenealogyGraphNode>> Ranks {
       get { return ranks; }
       set { ranks = value; }
     }
-
+    protected GenealogyGraph(GenealogyGraph original, Cloner cloner)
+      : base(original, cloner) {
+    }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new GenealogyGraph<TVertex>(this, cloner);
-    }
-    protected GenealogyGraph(GenealogyGraph<TVertex> original, Cloner cloner)
-      : base(original, cloner) {
+      return new GenealogyGraph(this, cloner);
     }
     [StorableConstructor]
     protected GenealogyGraph(bool deserializing) : base(deserializing) { }
-
     public GenealogyGraph() {
-      Ranks = new Dictionary<double, LinkedList<TVertex>>();
+      Ranks = new Dictionary<double, LinkedList<IGenealogyGraphNode>>();
     }
-    public override void AddVertex(TVertex vertex) {
-      if (!Ranks.ContainsKey(vertex.Rank)) {
-        Ranks[vertex.Rank] = new LinkedList<TVertex>();
-      }
-      Ranks[vertex.Rank].AddLast(vertex);
+    public override void AddVertex(IVertex vertex) {
+      var ggn = (IGenealogyGraphNode)vertex;
+      if (!Ranks.ContainsKey(ggn.Rank))
+        Ranks[ggn.Rank] = new LinkedList<IGenealogyGraphNode>();
+      Ranks[ggn.Rank].AddLast(ggn);
       base.AddVertex(vertex);
     }
-    public override void RemoveVertex(TVertex vertex) {
-      if (Ranks.ContainsKey(vertex.Rank)) {
-        Ranks[vertex.Rank].Remove(vertex);
+    public override void RemoveVertex(IVertex vertex) {
+      var ggn = (IGenealogyGraphNode)vertex;
+      if (Ranks.ContainsKey(ggn.Rank)) {
+        Ranks[ggn.Rank].Remove(ggn);
       }
       base.RemoveVertex(vertex);
     }
-    // updated event
     public event EventHandler GraphUpdated;
     private void OnGraphUpdated(object sender, EventArgs args) {
@@ -74,46 +67,12 @@
       if (updated != null) updated(sender, args);
     }
+
+    public new List<IGenealogyGraphNode> this[object content] {
+      get {
+        var result = base[content];
+        return result != null ? result.Cast<IGenealogyGraphNode>().ToList() : null;
+      }
+    }
   }
 
-  [StorableClass]
-  [Item("GenealogyGraph",
-    "A class representing a genealogy graph (of a population of individuals) in which each vertex stores a content.")]
-  public class GenealogyGraph<TVertex, TContent> : DirectedGraph<TVertex, TContent>, IGenealogyGraph<TVertex, TContent>
-    where TVertex : class, IGenealogyGraphNode<TContent>
-    where TContent : class, IItem {
-    [Storable]
-    private Dictionary<double, LinkedList<TVertex>> ranks;
-    public Dictionary<double, LinkedList<TVertex>> Ranks {
-      get { return ranks; }
-      set { ranks = value; }
-    }
-    protected GenealogyGraph(GenealogyGraph<TVertex, TContent> original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new GenealogyGraph<TVertex, TContent>(this, cloner);
-    }
-    public GenealogyGraph() {
-      Ranks = new Dictionary<double, LinkedList<TVertex>>();
-    }
-    public override void AddVertex(TVertex vertex) {
-      if (!Ranks.ContainsKey(vertex.Rank)) {
-        Ranks[vertex.Rank] = new LinkedList<TVertex>();
-      }
-      Ranks[vertex.Rank].AddLast(vertex);
-      base.AddVertex(vertex);
-    }
-    public override void RemoveVertex(TVertex vertex) {
-      if (Ranks.ContainsKey(vertex.Rank)) {
-        Ranks[vertex.Rank].Remove(vertex);
-      }
-      base.RemoveVertex(vertex);
-    }
-    // updated event
-    public event EventHandler GraphUpdated;
-    private void OnGraphUpdated(object sender, EventArgs args) {
-      var updated = GraphUpdated;
-      if (updated != null) updated(sender, args);
-    }
-  }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/GenealogyGraphNode.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/GenealogyGraphNode.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/GenealogyGraphNode.cs	(revision 10300)
@@ -110,5 +110,5 @@
     }
 
-    public new void AddForwardArc(IVertex target, double w = 0, object data = null) {
+    public new void AddForwardArc(IVertex target, double w = 0.0, object data = null) {
       var arc = new GenealogyGraphArc { Source = this, Target = (IGenealogyGraphNode)target, Data = data, Weight = w };
       base.AddForwardArc(arc);
@@ -122,7 +122,17 @@
   [StorableClass]
   [Item("GenealogyGraphNode", "A genealogy graph node which also has a Content")]
-  public class GenealogyGraphNode<T> : GenealogyGraphNode, IGenealogyGraphNode<T> where T : class,IItem {
-    public T Content { get; set; }
+  public class GenealogyGraphNode<T> : GenealogyGraphNode, IGenealogyGraphNode<T> where T : class, IItem {
+    public new T Content {
+      get { return (T)base.Content; }
+      set { base.Content = value; }
+    }
     public GenealogyGraphNode() { }
+    protected GenealogyGraphNode(GenealogyGraphNode<T> original, Cloner cloner)
+      : base(original, cloner) {
+      Content = original.Content;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GenealogyGraphNode<T>(this, cloner);
+    }
   }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/Interfaces/IGenealogyGraph.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/Interfaces/IGenealogyGraph.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/Interfaces/IGenealogyGraph.cs	(revision 10300)
@@ -24,17 +24,11 @@
 
 namespace HeuristicLab.EvolutionTracking {
-
-
-  public interface IGenealogyGraph : IGenealogyGraph<IGenealogyGraphNode> {
-  }
-  public interface IGenealogyGraph<TVertex> : IDirectedGraph<TVertex> where TVertex : class, IGenealogyGraphNode {
-    Dictionary<double, LinkedList<TVertex>> Ranks { get; set; }
+  public interface IGenealogyGraph : IDirectedGraph {
+    Dictionary<double, LinkedList<IGenealogyGraphNode>> Ranks { get; set; }
   }
 
-  public interface IGenealogyGraph<TVertex, in TContent> : IDirectedGraph<TVertex, TContent>, IGenealogyGraph<TVertex>
-    where TVertex : class, IGenealogyGraphNode<TContent>
-    where TContent : class, IItem {
-
-    List<TVertex> this[TContent content] { get; }
+  public interface IGenealogyGraph<T> : IDirectedGraph
+    where T : class,IItem {
+    Dictionary<double, LinkedList<IGenealogyGraphNode<T>>> Ranks { get; set; }
   }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/Interfaces/IGenealogyGraphNode.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/Interfaces/IGenealogyGraphNode.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/GenealogyGraph/Interfaces/IGenealogyGraphNode.cs	(revision 10300)
@@ -36,7 +36,4 @@
   }
 
-  public interface IGenealogyGraphNode<T> : IGenealogyGraphNode, IVertex<T> where T : class,IItem {
-
-  }
-
+  public interface IGenealogyGraphNode<T> : IGenealogyGraphNode, IVertex<T> where T : class,IItem { }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/HeuristicLab.EvolutionTracking-3.4.csproj.user
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/HeuristicLab.EvolutionTracking-3.4.csproj.user	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/HeuristicLab.EvolutionTracking-3.4.csproj.user	(revision 10300)
@@ -2,5 +2,5 @@
 <Project ToolsVersion="4.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
-    <ProjectView>ShowAllFiles</ProjectView>
+    <ProjectView>ProjectFiles</ProjectView>
   </PropertyGroup>
 </Project>
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterCrossoverOperator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterCrossoverOperator.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterCrossoverOperator.cs	(revision 10300)
@@ -29,23 +29,21 @@
   [StorableClass]
   [Item("AfterCrossoverOperator", "A generic operator that can record genealogical relationships between crossover parents and children.")]
-  public class AfterCrossoverOperator<TGraph, TVertex, TContent> : EvolutionTrackingOperator<TGraph, TVertex, TContent>
-    where TGraph : class,IGenealogyGraph<TVertex, TContent>
-    where TVertex : class,IGenealogyGraphNode<TContent>, new()
-    where TContent : class,IItem {
+  public class AfterCrossoverOperator<T> : EvolutionTrackingOperator
+    where T : class,IItem {
     private const string defaultParentsParameterName = "Parents";
     private const string defaultChildParameterName = "Child";
-    public IScopeTreeLookupParameter<TContent> ParentsParameter;
-    public ILookupParameter<TContent> ChildParameter;
+    public IScopeTreeLookupParameter<T> ParentsParameter;
+    public ILookupParameter<T> ChildParameter;
 
-    protected AfterCrossoverOperator(AfterCrossoverOperator<TGraph, TVertex, TContent> original, Cloner cloner)
+    protected AfterCrossoverOperator(AfterCrossoverOperator<T> original, Cloner cloner)
       : base(original, cloner) {
     }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new AfterCrossoverOperator<TGraph, TVertex, TContent>(this, cloner);
+      return new AfterCrossoverOperator<T>(this, cloner);
     }
 
     public AfterCrossoverOperator() {
-      ParentsParameter = new ScopeTreeLookupParameter<TContent>(defaultParentsParameterName);
-      ChildParameter = new LookupParameter<TContent>(defaultChildParameterName);
+      ParentsParameter = new ScopeTreeLookupParameter<T>(defaultParentsParameterName);
+      ChildParameter = new LookupParameter<T>(defaultChildParameterName);
       Parameters.Add(ParentsParameter);
       Parameters.Add(ChildParameter);
@@ -57,5 +55,5 @@
       var parentVertices = ExecutionContext.Scope.SubScopes.Select(s => lastGen[int.Parse(s.Name)]).ToList(); // because the individuals in the execution scope are copies of the ones in the graph
 
-      var childVertex = new TVertex {
+      var childVertex = new GenealogyGraphNode<T> {
         Content = ChildParameter.ActualValue,
         Rank = parentVertices[0].Rank + 1
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterManipulatorOperator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterManipulatorOperator.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterManipulatorOperator.cs	(revision 10300)
@@ -28,21 +28,19 @@
   [StorableClass]
   [Item("AfterCrossoverOperator", "Performs an action after the crossover operator is applied.")]
-  public class AfterManipulatorOperator<TGraph, TVertex, TContent> : EvolutionTrackingOperator<TGraph, TVertex, TContent>
-    where TGraph : class,IGenealogyGraph<TVertex, TContent>
-    where TVertex : class,IGenealogyGraphNode<TContent>, new()
-    where TContent : class,IItem {
+  public class AfterManipulatorOperator<T> : EvolutionTrackingOperator
+    where T : class,IItem {
 
     private const string ChildParameterName = "Child";
-    public ILookupParameter<TContent> ChildParameter;
+    public ILookupParameter<T> ChildParameter;
 
-    protected AfterManipulatorOperator(AfterManipulatorOperator<TGraph, TVertex, TContent> original, Cloner cloner)
+    protected AfterManipulatorOperator(AfterManipulatorOperator<T> original, Cloner cloner)
       : base(original, cloner) {
     }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new AfterManipulatorOperator<TGraph, TVertex, TContent>(this, cloner);
+      return new AfterManipulatorOperator<T>(this, cloner);
     }
 
     public AfterManipulatorOperator() {
-      ChildParameter = new LookupParameter<TContent>(ChildParameterName);
+      ChildParameter = new LookupParameter<T>(ChildParameterName);
       Parameters.Add(ChildParameter);
     }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterSolutionCreatorOperator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterSolutionCreatorOperator.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/AfterSolutionCreatorOperator.cs	(revision 10300)
@@ -26,8 +26,6 @@
   [StorableClass]
   [Item("AfterSolutionCreatorOperator", "An operator that runs after the solution creator and performs additional actions.")]
-  public class AfterSolutionCreatorOperator<TGraph, TVertex, TContent> : EvolutionTrackingOperator<TGraph, TVertex, TContent>
-    where TGraph : class,IGenealogyGraph<TVertex, TContent>
-    where TVertex : class,IGenealogyGraphNode<TContent>, new()
-    where TContent : class,IItem {
+  public class AfterSolutionCreatorOperator<T> : EvolutionTrackingOperator
+    where T : class,IItem {
 
     public override IOperation Apply() {
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/BeforeManipulatorOperator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/BeforeManipulatorOperator.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/BeforeManipulatorOperator.cs	(revision 10300)
@@ -29,21 +29,19 @@
   [StorableClass]
   [Item("AfterCrossoverOperator", "Performs an action after the crossover operator is applied.")]
-  public class BeforeManipulatorOperator<TGraph, TVertex, TContent> : EvolutionTrackingOperator<TGraph, TVertex, TContent>
-    where TGraph : class,IGenealogyGraph<TVertex, TContent>
-    where TVertex : class,IGenealogyGraphNode<TContent>, new()
-    where TContent : class,IItem {
+  public class BeforeManipulatorOperator<T> : EvolutionTrackingOperator
+    where T : class,IItem {
 
     private const string ChildParameterName = "Child";
-    public ILookupParameter<TContent> ChildParameter;
+    public ILookupParameter<T> ChildParameter;
 
-    protected BeforeManipulatorOperator(BeforeManipulatorOperator<TGraph, TVertex, TContent> original, Cloner cloner)
+    protected BeforeManipulatorOperator(BeforeManipulatorOperator<T> original, Cloner cloner)
       : base(original, cloner) {
     }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new BeforeManipulatorOperator<TGraph, TVertex, TContent>(this, cloner);
+      return new BeforeManipulatorOperator<T>(this, cloner);
     }
 
     public BeforeManipulatorOperator() {
-      ChildParameter = new LookupParameter<TContent>(ChildParameterName);
+      ChildParameter = new LookupParameter<T>(ChildParameterName);
       Parameters.Add(ChildParameter);
     }
@@ -52,7 +50,7 @@
       if (GenealogyGraph.Contains(ChildParameter.ActualValue)) {
         var child = ChildParameter.ActualValue;
-        var clone = (TContent)child.Clone();
-        var vChild = GenealogyGraph[child].Last();
-        var vClone = new TVertex { Content = clone, Rank = vChild.Rank - 0.5 };
+        var clone = (T)child.Clone();
+        var vChild = (IGenealogyGraphNode<T>)GenealogyGraph[child].Last();
+        var vClone = new GenealogyGraphNode<T> { Content = clone, Rank = vChild.Rank - 0.5 };
         GenealogyGraph.AddVertex(vClone);
         // adjust parent-child(clone) relationship in the graph
@@ -69,5 +67,5 @@
         vClone.AddForwardArc(vChild);
       } else { // this needs to be checked
-        var vChild = new TVertex { Content = ChildParameter.ActualValue, Rank = Generations.Value };
+        var vChild = new GenealogyGraphNode<T> { Content = ChildParameter.ActualValue, Rank = Generations.Value };
         GenealogyGraph.AddVertex(vChild);
       }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/EvolutionTrackingOperator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/EvolutionTrackingOperator.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Operators/EvolutionTrackingOperator.cs	(revision 10300)
@@ -28,8 +28,5 @@
 
 namespace HeuristicLab.EvolutionTracking {
-  public class EvolutionTrackingOperator<TGraph, TVertex, TContent> : SingleSuccessorOperator
-    where TGraph : class,IGenealogyGraph<TVertex, TContent>
-    where TVertex : class,IGenealogyGraphNode<TContent>
-    where TContent : class,IItem {
+  public class EvolutionTrackingOperator : SingleSuccessorOperator {
     // evolution tracking-related parameters
     private const string resultsParameterName = "Results";
@@ -49,14 +46,14 @@
       get { return GenerationsParameter.ActualValue; }
     }
-    public IGenealogyGraph<TVertex, TContent> GenealogyGraph {
+    public IGenealogyGraph GenealogyGraph {
       get {
         IResult result;
         if (!Results.ContainsKey(populationGraphParameterName)) {
-          result = new Result(populationGraphParameterName, new GenealogyGraph<TVertex, TContent>());
+          result = new Result(populationGraphParameterName, new GenealogyGraph());
           Results.Add(result);
         } else {
           result = Results[populationGraphParameterName];
         }
-        var graph = (GenealogyGraph<TVertex, TContent>)result.Value;
+        var graph = (GenealogyGraph)result.Value;
         return graph;
       }
@@ -66,9 +63,9 @@
       Parameters.Add(new LookupParameter<ResultCollection>(resultsParameterName));
     }
-    protected EvolutionTrackingOperator(EvolutionTrackingOperator<TGraph, TVertex, TContent> original, Cloner cloner)
+    protected EvolutionTrackingOperator(EvolutionTrackingOperator original, Cloner cloner)
       : base(original, cloner) {
     }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new EvolutionTrackingOperator<TGraph, TVertex, TContent>(this, cloner);
+      return new EvolutionTrackingOperator(this, cloner);
     }
   }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Plugin.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Plugin.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Plugin.cs	(revision 10300)
@@ -24,5 +24,5 @@
 namespace HeuristicLab.EvolutionTracking {
   [Plugin("HeuristicLab.EvolutionTracking", "Provides operators and related classes for tracking the evolution within a GA.", "3.4.2.7439")]
-  [PluginFile("HeuristicLab.EvolutionaryTracking-3.4.dll", PluginFileType.Assembly)]
+  [PluginFile("HeuristicLab.EvolutionTracking-3.4.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/SymbolGraph.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/SymbolGraph.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/SymbolGraph.cs	(revision 10300)
@@ -29,9 +29,9 @@
   [Item("Symbol graph", "A graph used to store the relationship between symbols in a population of individuals")]
   [StorableClass]
-  public class SymbolGraph : DirectedGraph<SymbolNode> {
+  public class SymbolGraph : DirectedGraph {
     [Storable]
     private readonly Dictionary<string, SymbolNode> nodeMap = new Dictionary<string, SymbolNode>();
 
-    public override void AddVertex(SymbolNode node) {
+    public void AddVertex(SymbolNode node) {
       if (nodeMap.ContainsKey(node.Label)) return; // node already present? do nothing
       nodeMap[node.Label] = node;
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 10300)
@@ -219,10 +219,4 @@
       <DependentUpon>SlidingWindowDataView.cs</DependentUpon>
     </Compile>
-    <Compile Include="SymbolicDataAnalysisGenealogyView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="SymbolicDataAnalysisGenealogyView.Designer.cs">
-      <DependentUpon>SymbolicDataAnalysisGenealogyView.cs</DependentUpon>
-    </Compile>
     <Compile Include="TextualSymbolicDataAnalysisModelView.cs">
       <SubType>UserControl</SubType>
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisGenealogyAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisGenealogyAnalyzer.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisGenealogyAnalyzer.cs	(revision 10300)
@@ -7,6 +7,5 @@
   [StorableClass]
   [Item("SymbolicDataAnalysisGenealogyAnalyzer", "")]
-  public class SymbolicDataAnalysisGenealogyAnalyzer : GenealogyAnalyzer<IGenealogyGraph<GenealogyGraphNode<ISymbolicExpressionTree>, ISymbolicExpressionTree>,
-    GenealogyGraphNode<ISymbolicExpressionTree>, ISymbolicExpressionTree> {
+  public class SymbolicDataAnalysisGenealogyAnalyzer : GenealogyAnalyzer<ISymbolicExpressionTree> {
   }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Creators/MultiSymbolicDataAnalysisExpressionCreator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Creators/MultiSymbolicDataAnalysisExpressionCreator.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Creators/MultiSymbolicDataAnalysisExpressionCreator.cs	(revision 10300)
@@ -95,5 +95,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation InstrumentedApply() {
       if (ClonedSymbolicExpressionTreeGrammarParameter.ActualValue == null) {
         SymbolicExpressionTreeGrammarParameter.ActualValue.ReadOnly = true;
@@ -104,5 +104,5 @@
         globalScope.Variables.Add(new Core.Variable(ClonedSymbolicExpressionTreeGrammarParameterName, (ISymbolicExpressionGrammar)SymbolicExpressionTreeGrammarParameter.ActualValue.Clone()));
       }
-      return base.Apply();
+      return base.InstrumentedApply();
     }
 
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisSingleObjectiveProblem.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisSingleObjectiveProblem.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisSingleObjectiveProblem.cs	(revision 10300)
@@ -30,8 +30,4 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-using TGraph = HeuristicLab.EvolutionTracking.IGenealogyGraph<HeuristicLab.EvolutionTracking.GenealogyGraphNode<HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree>,
-                                                              HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree>;
-using TVertex = HeuristicLab.EvolutionTracking.GenealogyGraphNode<HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree>;
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
@@ -122,5 +118,5 @@
       }
 
-      foreach (var op in Operators.OfType<GenealogyAnalyzer<TGraph, TVertex, ISymbolicExpressionTree>>()) {
+      foreach (var op in Operators.OfType<GenealogyAnalyzer<ISymbolicExpressionTree>>()) {
         op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
         op.PopulationParameter.ActualName = Evaluator.SymbolicExpressionTreeParameter.ActualName;
